variables:
  DOCKER_DRIVER: overlay2
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH

package:
  stage: package
  script:
    - ./gradlew fatJar --info

.buildDocker:
  image: docker
  stage: docker
  services:
  - docker:dind    
  
  before_script:
    - docker ps
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com

docker-tag:
  extends: .buildDocker
  except:
    - release
    - /^([0-9]+)\.([0-9]+\.)([0-9]+)$/
  script:
    - docker build -t $CONTAINER_IMAGE .
    - docker build --cache-from $CONTAINER_IMAGE:latest --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_NAME .
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_NAME

docker-latest:
  extends: .buildDocker
  only:
    - /^([0-9]+)\.([0-9]+\.)([0-9]+)$/
  script:
    - docker build -t $CONTAINER_IMAGE .
    - docker build --cache-from $CONTAINER_IMAGE:latest --tag $CONTAINER_IMAGE:$CI_COMMIT_TAG --tag $CONTAINER_IMAGE:latest .
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_TAG
    - docker push $CONTAINER_IMAGE:latest    
  